/**
 * This file Copyright (c) 2016-2018 Magnolia International
 * Ltd.  (http://www.magnolia-cms.com). All rights reserved.
 *
 *
 * This file is dual-licensed under both the Magnolia
 * Network Agreement and the GNU General Public License.
 * You may elect to use one or the other of these licenses.
 *
 * This file is distributed in the hope that it will be
 * useful, but AS-IS and WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE, TITLE, or NONINFRINGEMENT.
 * Redistribution, except as permitted by whichever of the GPL
 * or MNA you select, is prohibited.
 *
 * 1. For the GPL license (GPL), you can redistribute and/or
 * modify this file under the terms of the GNU General
 * Public License, Version 3, as published by the Free Software
 * Foundation.  You should have received a copy of the GNU
 * General Public License, Version 3 along with this program;
 * if not, write to the Free Software Foundation, Inc., 51
 * Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * 2. For the Magnolia Network Agreement (MNA), this file
 * and the accompanying materials are made available under the
 * terms of the MNA which accompanies this distribution, and
 * is available at http://www.magnolia-cms.com/mna.html
 *
 * Any modifications to this file must keep this entire header
 * intact.
 *
 */
package info.magnolia.ui.vaadin.gwt.client.widget.controlbar;

import com.google.gwt.user.client.ui.FlowPanel;

/**
 * Common base class for all widget-bars that need to toggle the focus.
 */
public class SimpleBar extends FlowPanel {

    protected final static String EDITOR_CLASS_NAME = "mgnlEditor";

    private final static String EDITOR_BAR_CLASS_NAME = "mgnlEditorBar";
    private final static String FOCUS_CLASS_NAME = "focus";
    private final static String CHILD_FOCUS_CLASS_NAME = "childFocus";

    public SimpleBar() {
        setStyleName(EDITOR_BAR_CLASS_NAME);
        addStyleName(EDITOR_CLASS_NAME);

        setVisible(false);
    }

    public void removeFocus() {
        removeStyleName(FOCUS_CLASS_NAME);
        removeStyleName(CHILD_FOCUS_CLASS_NAME);
    }

    public void setFocus(boolean child) {
        String CLASS_NAME = (child) ? CHILD_FOCUS_CLASS_NAME : FOCUS_CLASS_NAME;
        addStyleName(CLASS_NAME);
    }
}
